//Copyright (C) 2003  Thomas Schbel
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.

using System;
using MSHTML;
using System.Collections;
using System.ComponentModel;

namespace CSHttpUnit {
	public class CSWebForm {
		public CSWebForm() {
		}
		
		public CSWebRequest GetRequest(string id) {
			CSWebRequest request = new CSWebRequest();
			HTMLAnchorElement link = null;
			for(int i = 0; i < this.LINKS.Count; i++) {
				HTMLAnchorElement ae = (HTMLAnchorElement)this.LINKS[i];
				if(id == this.COMWrapperForPropertyAnchorID(this.LINKS[i], "id")) {
					link = (HTMLAnchorElement)ae;
				}
			}
			request.URL   = this.COMWrapperForPropertyAnchorHref(link, "href");
			request.FORM  = this.FORM;
			HTMLFormElementClass form = this.FORM;
			return request;
		}

		public CSWebRequest GetRequest(CSSubmitButton sbRequest) {
			CSWebRequest request = new CSWebRequest();
			IEControl ie = new IEControl();
			this.HDOC = ie.GetDocument();
			request.FORM = this.FORM;
			request.BUTTON = this.FindElement(sbRequest.ID);
			return request;			
		}

		[EditorBrowsable(EditorBrowsableState.Never)]
		public string ID {
			set	{
				_id = value;
			}
			get {
				return _id;
			}
		}

		[EditorBrowsable(EditorBrowsableState.Never)]
		public ArrayList LINKS {
			set {
				_links = value;
			}
			get {
				return _links;
			}
		}

		[EditorBrowsable(EditorBrowsableState.Never)]
		public HTMLFormElementClass FORM {
			set {
				_form = value;
			}
			get {
				return _form;
			}
		}

		[EditorBrowsable(EditorBrowsableState.Never)]
		public MSHTML.IHTMLDocument2 HDOC {
			set {
				_hDoc = value;
			}
			get {
				return _hDoc;
			}
		}

		private IHTMLElement FindElement(string buttonName) {
			IHTMLElementCollection ec = this.HDOC.all;
			foreach(IHTMLElement elem in ec) {
				if(elem.id == buttonName) {
					return elem;	
				}
			}
			return null;
		}

		private String COMWrapperForPropertyAnchorID(Object o, String name) {
			System.Type obType;
			obType = Type.GetType("System.__ComObject");
			object obj = o;
			return obType.InvokeMember(name, System.Reflection.BindingFlags.GetProperty, null, obj, null).ToString();
		}
		
		private String COMWrapperForPropertyAnchorHref(Object o, String name) {
			System.Type obType;
			obType = Type.GetType("System.__ComObject");
			object obj = o;
			return obType.InvokeMember(name, System.Reflection.BindingFlags.GetProperty, null, obj, null).ToString();
		}

		private string					_id				= null;
		private HTMLFormElementClass	_form			= null;
		private ArrayList				_links			= null;
		private MSHTML.IHTMLDocument2	_hDoc			= null;
	}
}
