//Copyright (C) 2003  Thomas Schbel
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.

using System;
using MSHTML;
using System.Collections;
using System.ComponentModel;

namespace CSHttpUnit {
	public class CSWebResponse {
		public CSWebResponse() {
		}

		public string GetTitle() {
			return TITLE;
		}

		public CSWebTable GetTableWithID(string id) {
			CSWebTable wt = new CSWebTable();
			HTMLTableClass table = this.HDOC.all.item(id, 0) as HTMLTableClass;
			wt.TABLE = table;
			wt.ID = table.id;
			return wt;
		}

		public CSWebForm GetFormWithID(string id) {
			CSWebForm wf = new CSWebForm();
			HTMLFormElementClass form = this.HDOC.all.item(id, 0) as HTMLFormElementClass;
			IHTMLElementCollection ecLinks   = (IHTMLElementCollection)this.HDOC.anchors;
			
			ArrayList alLinks = new ArrayList();
			foreach(HTMLAnchorElement a in ecLinks) {
				alLinks.Add(a);
			}	
			wf.ID = form.id;
			wf.FORM = form;
			wf.LINKS = alLinks;
			return wf;
		}

		public CSWebLink GetLinkWithID(string id) {
			CSWebLink wl = new CSWebLink();
			HTMLAnchorElementClass link = this.HDOC.all.item(id, 0) as HTMLAnchorElementClass;
			wl.LINK = link;
			wl.ID   = link.id;
			wl.URL  = link.href;
			return wl;
		}
		
		private String COMWrapperForPropertyLinks(Object o, String name) {
			System.Type obType;
			obType = Type.GetType("System.__ComObject");
			object obj = o;
			return obType.InvokeMember(name, System.Reflection.BindingFlags.GetProperty, null, obj, null).ToString();
		}
		
		[EditorBrowsable(EditorBrowsableState.Never)]
		public string TITLE {
			set	{
				_title = value;
			}
			get {
				return _title;
			}
		} 
		
		[EditorBrowsable(EditorBrowsableState.Never)]
		public MSHTML.IHTMLDocument2 HDOC {
			set {
				_hDoc = value;
			}
			get {
				return _hDoc;
			}
		}
		
		[EditorBrowsable(EditorBrowsableState.Never)]
		public HTMLFormElementClass FORM {
			set {
				_form = value;
			}
			get {
				return _form;
			}
		}

		private string					_title			= null;
		private MSHTML.IHTMLDocument2	_hDoc			= null;
		private HTMLFormElementClass	_form			= null;
	}
}
