//Copyright (C) 2003  Thomas Schbel
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.

using System;
using MSHTML;
using System.Collections;
using System.ComponentModel;

namespace CSHttpUnit {
	public class CSWebTable {
		public CSWebTable(){
		}

		public string GetCellAsText(int row, int col) {
			_alCells = new ArrayList();
			_alRows  = new ArrayList();
			HTMLTableClass table = this.TABLE;
			IHTMLElementCollection ecRows = (IHTMLElementCollection)table.rows;
			
			foreach(HTMLTableRow r in ecRows) {
				_alRows.Add(r);
			}	
			HTMLTableRow oRow = (HTMLTableRow)_alRows[row];			

			IHTMLElementCollection ecCells = (IHTMLElementCollection) this.COMWrapperForPropertyCells(oRow, "cells");

			foreach(HTMLTableCell c in ecCells) {
				_alCells.Add(c);
			}
			HTMLTableCell oCell = (HTMLTableCell)_alCells[col];
			
			return this.COMWrapperForPropertyInnerText(oCell, "innerText");
		}
		
		public int GetRowCount() {
			_alRows  = new ArrayList();
			HTMLTableClass table = this.TABLE;
			IHTMLElementCollection ecRows = (IHTMLElementCollection)table.rows;
			foreach(HTMLTableRow r in ecRows) {
				_alRows.Add(r);
			}	
			return _alRows.Count;
		}
		
		[EditorBrowsable(EditorBrowsableState.Never)]
		public string ID {
			set	{
				_id = value;
			}
			get {
				return _id;
			}
		}

		[EditorBrowsable(EditorBrowsableState.Never)]
		public HTMLTableClass TABLE {
			set {
				_table = value;
			}
			get {
				return _table;
			}
		}

		private String COMWrapperForPropertyInnerText(Object o, String name) {
			System.Type obType;
			obType = Type.GetType("System.__ComObject");
			object obj = o;
			return obType.InvokeMember(name, System.Reflection.BindingFlags.GetProperty, null, obj, null).ToString();
		}

		private Object COMWrapperForPropertyCells(Object o, String name) {
			System.Type obType;
			obType = Type.GetType("System.__ComObject");
			object obj = o;
			return obType.InvokeMember(name, System.Reflection.BindingFlags.GetProperty, null, obj, null);
		}

		private string				_id				= null;
		private HTMLTableClass		_table			= null;
		private ArrayList			_alCells		= null;
		private ArrayList			_alRows			= null;
	}
}
